<template>
  <div>
    <!-- eslint-disable-next-line vue/no-v-html -->
    <div class="top-text" v-html="topTextHtml" />

    <div class="row">
      <div class="col-12 mb-2">
        <input
          v-model="searchInput"
          type="text"
          class="form-control form-control-sm"
          placeholder="Search among instances"
        >
      </div>
    </div>

    <o-table
      :data="rows"
      :loading="loading"

      aria-next-label="Next page"
      aria-previous-label="Previous page"
      aria-page-label="Page"
      aria-current-label="Current page"

      mobile-sort-class="mobile-sort"

      backend-sorting
      :default-sort="sort.field"
      :default-sort-direction="sort.direction"
      @sort="onSortChange"
    >
      <o-table-column
        v-for="column in columns"
        v-slot="props"
        :key="column.field"
        :field="column.field"
        :label="column.label"
        :sortable="column.sortable"
        :numeric="column.numeric"
        :width="column.width"
      >
        <span
          v-if="column.field === 'name'"
          :title="getInstanceNameTitle(props.row)"
        >{{ props.row.name }}</span>

        <a
          v-else-if="column.field === 'host'"
          :href="getUrl(props.row.host)"
          target="_blank"
        >{{ props.row.host }}</a>

        <div
          v-else-if="column.field === 'version'"
          class="version"
        >
          <code :title="props.row.version">{{ props.row.version }}</code>
        </div>

        <div v-else-if="column.field === 'signupAllowed'">
          <span
            v-if="props.row.signupAllowed"
            class="check-mark"
          >&#x2714;</span>
          <span v-else>&#x274C;</span>
        </div>

        <div v-else-if="column.field === 'liveEnabled'">
          <span
            v-if="props.row.liveEnabled"
            class="check-mark"
          >&#x2714;</span>
          <span v-else>&#x274C;</span>
        </div>

        <div
          v-else-if="column.field === 'country'"
          class="country-flag"
          :title="props.row.country"
        >
          <country-flag
            v-if="props.row.country"
            :country="props.row.country"
          />
        </div>

        <div
          v-else-if="column.field === 'health'"
          class="icon-cell health-icon"
          :title="'In recent days, the instance was available ' + props.row.health + '% of the time.'"
        >
          <smile
            v-if="getIconName(props.row.health) === 'smile'"
            :style="{ fill: getIconColor(props.row.health) }"
          />
          <meh
            v-if="getIconName(props.row.health) === 'meh'"
            :style="{ fill: getIconColor(props.row.health) }"
          />
          <frown
            v-if="getIconName(props.row.health) === 'frown'"
            :style="{ fill: getIconColor(props.row.health) }"
          />
        </div>

        <div v-else>
          {{ formatNumber(props.row[column.field]) }}
        </div>
      </o-table-column>
    </o-table>

    <div class="below-table">
      <div class="per-page">
        <span>Rows per page</span>

        <select
          id="rows-per-page"
          v-model.number="perPage"
          name="rows-per-page"
          @change="onPerPageChanged"
        >
          <option value="1">
            1
          </option>
          <option value="10">
            10
          </option>
          <option value="50">
            50
          </option>
          <option value="100">
            100
          </option>
        </select>
      </div>

      <div class="pagination">
        <div
          role="button"
          class="previous"
          :class="{ disabled: currentPage === 1 }"
          @click="previousPage()"
        >
          <div class="chevron left" />
          Prev
        </div>

        <div class="total">
          {{ getFirstRowCount() }} - {{ getLastRowCount() }} of {{ totalRecords }}
        </div>

        <div
          role="button"
          class="next"
          :class="{ disabled: currentPage === getLastPage() }"
          @click="nextPage()"
        >
          Next
          <div class="chevron right" />
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import Smile from '../icons/Smile.vue'
import Frown from '../icons/Frown.vue'
import Meh from '../icons/Meh.vue'
import { Instance } from '../../../shared/models/index.js'
import { getConfig } from '../shared/config.js'
import { listInstances } from '../shared/instance-http.js'
import { defineComponent } from 'vue'
import { formatNumber } from '@/shared/utils.js'

export default defineComponent({
  components: {
    smile: Smile,
    frown: Frown,
    meh: Meh
  },

  data () {
    return {
      columns: [
        {
          label: 'Name',
          field: 'name',
          sortable: true,
          numeric: false
        },
        {
          label: 'URL',
          field: 'host',
          sortable: true,
          numeric: false
        },
        {
          label: 'Version',
          field: 'version',
          sortable: true,
          numeric: false
        },
        {
          label: 'Following',
          field: 'totalInstanceFollowing',
          sortable: true,
          numeric: true
        },
        {
          label: 'Followers',
          field: 'totalInstanceFollowers',
          sortable: true,
          numeric: true
        },
        {
          label: 'Local videos',
          field: 'totalLocalVideos',
          sortable: true,
          numeric: true
        },
        {
          label: 'Total videos',
          field: 'totalVideos',
          sortable: true,
          numeric: true
        },
        {
          label: 'Users',
          field: 'totalUsers',
          sortable: true,
          numeric: true
        },
        {
          label: 'Signup',
          field: 'signupAllowed',
          type: 'boolean',
          sortable: true,
          numeric: false
        },
        {
          label: 'Live',
          field: 'liveEnabled',
          type: 'boolean',
          sortable: true,
          numeric: false
        },
        {
          label: 'Location',
          field: 'country',
          type: 'string',
          sortable: true,
          width: '40px',
          numeric: false
        },
        {
          label: 'Health',
          field: 'health',
          sortable: true,
          width: '40px',
          numeric: false
        }
      ],

      loading: false,

      rows: [] as Instance[],
      totalRecords: null as number,
      perPage: 10,
      currentPage: 1,

      paginationOptions: {
        enabled: true,
        perPage: this.perPage
      },

      topTextHtml: '',

      search: '',
      searchTimeout: null,

      sort: {
        field: 'createdAt',
        direction: 'desc'
      },

      categoriesOr: undefined,
      languagesOr: undefined,
      customizations: undefined
    }
  },

  computed: {
    searchInput: {
      get (): string {
        return this.search
      },

      set (val: string) {
        if (this.searchTimeout) clearTimeout(this.searchTimeout)

        this.searchTimeout = setTimeout(() => {
          this.search = val

          this.onSearchChanged()
        }, 300)
      }
    }
  },

  async mounted () {
    this.loadQueryParams()

    this.loadData()

    const config = await getConfig()
    this.topTextHtml = config.instanceClientWarning
  },

  methods: {

    getUrl (host: string) {
      return 'https://' + host
    },

    formatNumber (value: number) {
      return formatNumber(value)
    },

    getIconName (health: number) {
      if (health > 90) return 'smile'
      if (health > 50) return 'meh'
      return 'frown'
    },

    getIconColor (health: number) {
      if (health > 98) return '#08cd36'
      if (health > 90) return '#81c307'
      if (health > 70) return '#cfb11b'
      if (health > 50) return '#e67a3c'
      if (health > 20) return '#e7563c'

      return '#f44141'
    },

    getInstanceNameTitle (instance: Instance) {
      return instance.name + '\nAdded on ' + new Date(instance.createdAt).toLocaleString()
    },

    getLastPage() {
      return Math.ceil(this.totalRecords / this.perPage)
    },

    onPageChange (params: { currentPage: number }) {
      this.currentPage = params.currentPage
      this.setQueryParam('page', this.currentPage)
      this.loadData()
    },

    onPerPageChanged () {
      this.currentPage = 1
      this.setQueryParam('page', this.currentPage)
      this.loadData()
    },

    onSortChange (sortObj: { field: string }, direction: 'asc' | 'desc') {
      this.sort = {
        field: sortObj.field,
        direction
      }

      this.setQueryParam('sort', this.buildSortString())

      this.loadData()
    },

    onSearchChanged () {
      this.setQueryParam('search', this.search)
      this.loadData()
    },

    setQueryParam (name: string, value: string | number) {
      let query = { ...this.$route.query }

      if (value) query = Object.assign(query, { [name]: value })
      else delete query[name]

      this.$router.push({
        path: this.$route.path,
        query
      })
    },

    loadQueryParams () {
      for (var key in this.$route.query){
        switch (key) {
          case 'sort':
            this.sort = this.parseSortString(this.$route.query[key] as string)
            break

          case 'page':
            this.currentPage = +this.$route.query[key]
            break

          case 'search':
            this.search = this.searchInput = this.$route.query[key] as string
            break

          case 'categoriesOr':
            this.categoriesOr = this.$route.query[key]
            break

          case 'languagesOr':
            this.languagesOr = this.$route.query[key]
            break

          case 'customizations':
            this.customizations = this.$route.query[key]
            break
        }
      }
    },

    previousPage () {
      if (this.currentPage === 1) return

      this.currentPage--
      this.loadData()
    },

    nextPage () {
      if(this.currentPage === this.getLastPage()) return

      this.currentPage++
      this.loadData()
    },

    getFirstRowCount () {
      return Math.min((this.currentPage - 1) * this.perPage + 1, this.totalRecords)
    },

    getLastRowCount () {
      return Math.min(this.currentPage * this.perPage, this.totalRecords)
    },

    async loadData () {
      this.loading = true

      const response = await listInstances({
        page: this.currentPage,
        perPage: this.perPage,
        sort: this.buildSortString(),
        search: this.search,
        categoriesOr: this.categoriesOr,
        languagesOr: this.languagesOr,
        customizations: this.customizations
      })

      this.loading = false

      this.rows = response.data
      this.totalRecords = response.total
    },

    buildSortString () {
      let sort = this.sort.direction === 'asc'
        ? ''
        : '-'

      sort += this.sort.field

      return sort
    },

    parseSortString (sort: string) {
      const direction = sort.startsWith('-')
        ? 'desc'
        : 'asc'

      const field = sort.replace(/^-/, '')

      return {
        field,
        direction
      }
    }
  }
})
</script>

<style lang="scss">
  table {
    width: 100%;
  }

  th {
    cursor: pointer;
  }

  td, th {
    font-size: 0.8em;
    vertical-align: middle !important;
    border-top: 1px solid #dee2e6;
    padding: 0.75em;

    &:first-child {
      padding-left: 0;
    }

    &:last-child {
      padding-right: 0;
      text-align: right;
    }
  }

  .name, .host {
    max-width: 170px;
    overflow: hidden;
    text-overflow: ellipsis;
    white-space: nowrap;
  }

  .name, .host, .version {
    padding-right: 5px !important;
  }

  .version {
    max-width: 80px;
    overflow: hidden;
    text-overflow: ellipsis;
    white-space: nowrap;
  }

  .icon-cell {
    padding: 0 !important;
    text-align: center !important;
    vertical-align: middle !important;

    &.health-icon {
      margin-left: auto;
      width: 20px !important;
      height: 20px !important;
    }
  }

  .country-flag {
    max-height: 20px;
    display: flex;
    align-items: center;
  }

  .top-text {
    font-size: 14px;
    margin-bottom: 20px;
  }

  a,
  a:hover {
    color: #e85d00;
  }

  .below-table {
    display: flex;
    justify-content: space-between;
    font-size: 14px;
    color: #909399;
    margin-top: 20px;
  }

  .per-page {

    select {
      margin-left: 10px;
      background: transparent;
      border: none;
      color: #606266;
      font-weight: bold;
    }
  }

  .pagination {
    display: flex;
  }

  .total {
    margin: 0 10px;
  }

  .previous,
  .next {
    display: flex;
    cursor: pointer;
    font-weight: bold;
    color: #606266;

    &.disabled {
      opacity: 0.5;
      cursor: not-allowed;
    }

    &:not(.disabled):hover {
      opacity: 0.8;
    }
  }

  .mobile-sort {
    display: none;
  }

  .chevron {
    border-radius: 15%;
    position: relative;
    margin: 0 8px;

    &:after {
      content: "";
      position: absolute;
      display: block;
      left: 50%;
      top: 50%;
      margin-top: -6px;
      border-top: 6px solid transparent;
      border-bottom: 6px solid transparent;
    }

    &.left:after {
      border-right: 6px solid #606266;
      margin-left: -3px;
    }

    &.right:after {
      border-left: 6px solid #606266;
      margin-left: -3px;
    }
  }
</style>
